Video for Linux Two API Specification: Revision 0.24
Prev |  | Next

# ioctl VIDIOC_CROPCAP

## Name

VIDIOC_CROPCAP -- Information about the video cropping and scaling abilities

## Synopsis

``int ioctl`(int fd, int request, struct v4l2_cropcap *argp);`

## Arguments

`fd`

  File descriptor returned by `open()`.

`request`

  VIDIOC_CROPCAP

`argp`

## Description

Applications use this function to query the cropping limits, the pixel aspect of images and to calculate scale factors. They set the `type` field of a v4l2_cropcap structure to the respective buffer (stream) type and call the `VIDIOC_CROPCAP` ioctl with a pointer to this structure. Drivers fill the rest of the structure. The results are constant except when switching the video standard. Remember this switch can occur implicit when switching the video input or output.

Table 1. struct `v4l2_cropcap`

enum v4l2_buf_type | `type` | Type of the data stream, set by the application. Only these types are valid here: `V4L2_BUF_TYPE_VIDEO_CAPTURE`, `V4L2_BUF_TYPE_VIDEO_OUTPUT`, `V4L2_BUF_TYPE_VIDEO_OVERLAY`, and custom (driver defined) types with code `V4L2_BUF_TYPE_PRIVATE` and higher.
struct v4l2_rect | `bounds` | Defines the window within capturing or output is possible, this may exclude for example the horizontal and vertical blanking areas. The cropping rectangle cannot exceed these limits. Width and height are defined in pixels, the driver writer is free to choose origin and units of the coordinate system in the analog domain.
struct v4l2_rect | `defrect` | Default cropping rectangle, it shall cover the "whole picture". Assuming pixel aspect 1/1 this could be for example a 640 × 480 rectangle for NTSC, a 768 × 576 rectangle for PAL and SECAM centered over the active picture area. The same co-ordinate system as for `bounds` is used.
struct v4l2_fract | `pixelaspect` | This is the pixel aspect (y / x) when no scaling is applied, the ratio of the actual sampling frequency and the frequency required to get square pixels. When cropping coordinates refer to square pixels, the driver sets `pixelaspect` to 1/1. Other common values are 54/59 for PAL and SECAM, 11/10 for NTSC sampled according to [ITU BT.601].

Table 2. struct `v4l2_rect`

__s32 | `left` | Horizontal offset of the top, left corner of the rectangle, in pixels.
__s32 | `top` | Vertical offset of the top, left corner of the rectangle, in pixels.
__s32 | `width` | Width of the rectangle, in pixels.
__s32 | `height` | Height of the rectangle, in pixels. Width and height cannot be negative, the fields are signed for hysterical reasons.

## Return Value

On success 0 is returned, on error -1 and the `errno` variable is set appropriately:

EINVAL

  The struct v4l2_cropcap `type` is invalid or the ioctl is not supported. This is not permitted for video capture, output and overlay devices, which must support `VIDIOC_CROPCAP`.

Prev | Home | Next
V4L2 ioctl() | Up | ioctl VIDIOC_DBG_G_REGISTER, VIDIOC_DBG_S_REGISTER